// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _VJ1A_H_
#define _VJ1A_H_  // guard

#include "verilated_heavy.h"

//==========

class Vj1a__Syms;

//----------

VL_MODULE(Vj1a) {
  public:
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk,0,0);
    VL_IN8(resetq,0,0);
    VL_OUT8(uart0_wr,0,0);
    VL_OUT8(uart0_rd,0,0);
    VL_OUT8(uart_w,7,0);
    VL_IN8(uart0_busy,0,0);
    VL_IN8(uart0_valid,0,0);
    VL_IN8(uart0_data,7,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    CData/*0:0*/ v__DOT__io_wr;
    CData/*0:0*/ v__DOT__interrupt;
    CData/*4:0*/ v__DOT___j1__DOT__rsp;
    CData/*4:0*/ v__DOT___j1__DOT__rspN;
    CData/*4:0*/ v__DOT___j1__DOT__dsp;
    CData/*4:0*/ v__DOT___j1__DOT__dspN;
    CData/*0:0*/ v__DOT___j1__DOT__interrupt;
    CData/*0:0*/ v__DOT___j1__DOT__fetch;
    CData/*0:0*/ v__DOT___j1__DOT__notreboot;
    CData/*1:0*/ v__DOT___j1__DOT__dspI;
    CData/*1:0*/ v__DOT___j1__DOT__rspI;
    CData/*0:0*/ v__DOT___j1__DOT__is_alu;
    CData/*0:0*/ v__DOT___j1__DOT__eint;
    CData/*0:0*/ v__DOT___j1__DOT__dint;
    CData/*0:0*/ v__DOT___j1__DOT__interrupt_enableN;
    CData/*0:0*/ v__DOT___j1__DOT__interrupt_enableN_return;
    SData/*15:0*/ v__DOT__ticks;
    SData/*15:0*/ v__DOT__porta_dir;
    SData/*15:0*/ v__DOT__porta_out;
    SData/*15:0*/ v__DOT__portb_dir;
    SData/*15:0*/ v__DOT__portb_out;
    SData/*15:0*/ v__DOT__portc_dir;
    SData/*15:0*/ v__DOT__portc_out;
    SData/*15:0*/ v__DOT___j1__DOT__insn_from_memory;
    SData/*15:0*/ v__DOT___j1__DOT__st0;
    SData/*15:0*/ v__DOT___j1__DOT__st0N;
    SData/*15:0*/ v__DOT___j1__DOT__pc;
    SData/*15:0*/ v__DOT___j1__DOT__pcN;
    SData/*15:0*/ v__DOT___j1__DOT__insn;
    SData/*15:0*/ v__DOT___j1__DOT__pc_plus_2;
    SData/*15:0*/ v__DOT___j1__DOT__rstkD;
    IData/*16:0*/ v__DOT__ticks_plus_1;
    IData/*16:0*/ v__DOT___j1__DOT__minus;
    IData/*31:0*/ v__DOT___j1__DOT__umstar;
    WData/*511:0*/ v__DOT___j1__DOT__rstack__DOT__stack[16];
    WData/*511:0*/ v__DOT___j1__DOT__dstack__DOT__stack[16];
    SData/*15:0*/ v__DOT___j1__DOT__mem[8192];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    CData/*0:0*/ __Vclklast__TOP__clk;
    CData/*0:0*/ __Vclklast__TOP__resetq;
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    Vj1a__Syms* __VlSymsp;  // Symbol table
    
    // CONSTRUCTORS
  private:
    VL_UNCOPYABLE(Vj1a);  ///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible with respect to DPI scope names.
    Vj1a(const char* name = "TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~Vj1a();
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval() { eval_step(); }
    /// Evaluate when calling multiple units/models per time step.
    void eval_step();
    /// Evaluate at end of a timestep for tracing, when using eval_step().
    /// Application must call after all eval() and before time changes.
    void eval_end_step() {}
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(Vj1a__Syms* __restrict vlSymsp);
  public:
    void __Vconfigure(Vj1a__Syms* symsp, bool first);
  private:
    static QData _change_request(Vj1a__Syms* __restrict vlSymsp);
    static QData _change_request_1(Vj1a__Syms* __restrict vlSymsp);
  public:
    static void _combo__TOP__6(Vj1a__Syms* __restrict vlSymsp);
  private:
    void _ctor_var_reset() VL_ATTR_COLD;
  public:
    static void _eval(Vj1a__Syms* __restrict vlSymsp);
  private:
#ifdef VL_DEBUG
    void _eval_debug_assertions();
#endif  // VL_DEBUG
  public:
    static void _eval_initial(Vj1a__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _eval_settle(Vj1a__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _initial__TOP__1(Vj1a__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _sequent__TOP__2(Vj1a__Syms* __restrict vlSymsp);
    static void _sequent__TOP__3(Vj1a__Syms* __restrict vlSymsp);
    static void _sequent__TOP__5(Vj1a__Syms* __restrict vlSymsp);
    static void _settle__TOP__4(Vj1a__Syms* __restrict vlSymsp) VL_ATTR_COLD;
} VL_ATTR_ALIGNED(VL_CACHE_LINE_BYTES);

//----------


#endif  // guard
